<html>
<head>
<title>OgreScriptLexer.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreScriptLexer.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreScriptLexer_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __ScriptLexer_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __ScriptLexer_H_</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreSharedPtr_8h.html">OgreSharedPtr.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreDataStream_8h.html">OgreDataStream.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreStringConverter_8h.html">OgreStringConverter.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00050"></a>00050     <span class="keyword">enum</span>{
<a name="l00051"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4aae39847e17513a577aca5635a97521be">00051</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4aae39847e17513a577aca5635a97521be">TID_LBRACKET</a> = 0, <span class="comment">// {</span>
<a name="l00052"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a712a771181ea5b86bfde241d6a2d8993">00052</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a712a771181ea5b86bfde241d6a2d8993">TID_RBRACKET</a>, <span class="comment">// }</span>
<a name="l00053"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a878d2261acfefcb0d7300c8c45b5c02d">00053</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a878d2261acfefcb0d7300c8c45b5c02d">TID_COLON</a>, <span class="comment">// :</span>
<a name="l00054"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a0b23f6bf647e3b550221beb8a573b893">00054</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a0b23f6bf647e3b550221beb8a573b893">TID_VARIABLE</a>, <span class="comment">// $...</span>
<a name="l00055"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a86bb0fccced23e5307a00cceb95790b5">00055</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a86bb0fccced23e5307a00cceb95790b5">TID_WORD</a>, <span class="comment">// *</span>
<a name="l00056"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a77ce47edadffee44efce275d84f25136">00056</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a77ce47edadffee44efce275d84f25136">TID_QUOTE</a>, <span class="comment">// &quot;*&quot;</span>
<a name="l00057"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a43223177f86aeb6a731970fec69dc4ad">00057</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a43223177f86aeb6a731970fec69dc4ad">TID_NEWLINE</a>, <span class="comment">// \n</span>
<a name="l00058"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a77822e20ddde8583a6b89408ab2a29b3">00058</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a77822e20ddde8583a6b89408ab2a29b3">TID_UNKNOWN</a>,
<a name="l00059"></a><a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a28c5d661274c02f913e9114e8dfedab9">00059</a>         <a class="code" href="group__General.html#ggab147e6cc4966a93d6035190c6e3572a4a28c5d661274c02f913e9114e8dfedab9">TID_END</a>
<a name="l00060"></a>00060     };
<a name="l00061"></a>00061 
<a name="l00065"></a><a class="code" href="structOgre_1_1ScriptToken.html">00065</a>     <span class="keyword">struct </span><a class="code" href="structOgre_1_1ScriptToken.html" title="This struct represents a token, which is an ID&#39;d lexeme from the parsing input stream.">ScriptToken</a>
<a name="l00066"></a>00066     {
<a name="l00068"></a><a class="code" href="structOgre_1_1ScriptToken.html#ae229067d36cb90679ff2cbfc6d0ac59d">00068</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="structOgre_1_1ScriptToken.html#ae229067d36cb90679ff2cbfc6d0ac59d" title="This is the lexeme for this token.">lexeme</a>, <a class="code" href="structOgre_1_1ScriptToken.html#a620d045e9cea2ce41df4c5ec1b2e0d61">file</a>;
<a name="l00070"></a><a class="code" href="structOgre_1_1ScriptToken.html#a3c41790bd168ff84d8558ed1597daa82">00070</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="structOgre_1_1ScriptToken.html#a3c41790bd168ff84d8558ed1597daa82" title="This is the id associated with the lexeme, which comes from a lexeme-token id mapping.">type</a>;
<a name="l00072"></a><a class="code" href="structOgre_1_1ScriptToken.html#a83500d1c1b1528eca630836658a56f90">00072</a>         <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> <a class="code" href="structOgre_1_1ScriptToken.html#a83500d1c1b1528eca630836658a56f90" title="This holds the line number of the input stream where the token was found.">line</a>;
<a name="l00073"></a>00073     };
<a name="l00074"></a><a class="code" href="group__General.html#ga836dfb2604ddbe9a5a43644ee826e41e">00074</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;ScriptToken&gt;</a> <a class="code" href="group__General.html#ga836dfb2604ddbe9a5a43644ee826e41e">ScriptTokenPtr</a>;
<a name="l00075"></a><a class="code" href="group__General.html#gaf5d5c336a97b2fd3dce37648e968c51c">00075</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;ScriptTokenPtr&gt;::type</a> <a class="code" href="group__General.html#gaf5d5c336a97b2fd3dce37648e968c51c">ScriptTokenList</a>;
<a name="l00076"></a><a class="code" href="group__General.html#gacd063ace8e2697904ef8c500b1096902">00076</a>     <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;ScriptTokenList&gt;</a> <a class="code" href="group__General.html#gacd063ace8e2697904ef8c500b1096902">ScriptTokenListPtr</a>;
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classOgre_1_1ScriptLexer.html">00078</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ScriptLexer.html">ScriptLexer</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">ScriptCompilerAlloc</a>
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080     <span class="keyword">public</span>:
<a name="l00081"></a>00081         <a class="code" href="classOgre_1_1ScriptLexer.html">ScriptLexer</a>();
<a name="l00082"></a><a class="code" href="classOgre_1_1ScriptLexer.html#a17040332d82172d0035e0301d9b07f5a">00082</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1ScriptLexer.html#a17040332d82172d0035e0301d9b07f5a">~ScriptLexer</a>() {}
<a name="l00083"></a>00083 
<a name="l00085"></a>00085         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">ScriptTokenListPtr</a> tokenize(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;str, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;source);
<a name="l00086"></a>00086     <span class="keyword">private</span>: <span class="comment">// Private utility operations</span>
<a name="l00087"></a>00087         <span class="keywordtype">void</span> setToken(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;lexeme, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> line, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;source, <a class="code" href="group__General.html#gaf5d5c336a97b2fd3dce37648e968c51c">ScriptTokenList</a> *tokens);
<a name="l00088"></a>00088         <span class="keywordtype">bool</span> isWhitespace(Ogre::String::value_type c) <span class="keyword">const</span>;
<a name="l00089"></a>00089         <span class="keywordtype">bool</span> isNewline(Ogre::String::value_type c) <span class="keyword">const</span>;
<a name="l00090"></a>00090     };
<a name="l00091"></a>00091 
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
